##Import der benötigten Bibliotheken
from utime import sleep_us, ticks_us
from machine import Pin, PWM
from time import sleep

#Servomotor am GPIO12 angeschlossen
servoPin = 12

#konfigurieren der PWM Kanäle für den Servomotor
pwm = PWM(Pin(servoPin))
#der Servomotor Typ SG90 arbeitet mit 50Hz
pwm.freq(50)

#ermittelte Positionen für die Schaufel
valUnten = 1580000
valOben = 500000

buzzer = PWM(Pin(22))

def makeBeep():
    buzzer.freq(350)
    buzzer.duty_u16(1000)
    sleep(0.1)
    buzzer.duty_u16(0)
    sleep(0.1)
    buzzer.freq(750)
    buzzer.duty_u16(1000)
    sleep(0.1)
    buzzer.duty_u16(0)
    sleep(0.1)
    buzzer.freq(350)
    buzzer.duty_u16(1000)
    sleep(0.1)
    buzzer.duty_u16(0)
    sleep(0.1)

def readUltrasonicSensor():
    #definieren das der Pin als Ausgang dient
    pin=machine.Pin(3, machine.Pin.OUT)
    #Pin aktivieren
    pin.on()
    #zwei Microsekunden warten
    sleep_us(2)
    #Pin deaktivieren
    pin.off()
    #zehn Microsekunden warten
    sleep_us(10)
    #Pin aktivieren
    pin.on()
    #definieren das der Pin als Eingang
    pin=machine.Pin(3, machine.Pin.IN)
    #Endlosschleife solange der Pin LOW/0 ist
    while pin.value() == 0:
      pass
    #zwischenspeichern der vergangenen Microsekunden
    ticks1 = ticks_us()
    #Endlosschleife solange der Pin HIGH/1 ist
    while pin.value() == 1:
      pass
    #zwischenspeichern der vergangenen Microsekunden
    ticks2 = ticks_us()
    #die differenz zwischen den beiden Werten geteilt durch 58 sind
    #die Zentimer zum Objekt
    return (ticks2 - ticks1)  /  58.0
  
#Funktion zum öffnen des Mundes
def oeffneMund():
    global valOben
    print("oeffneMund")
    pwm.duty_ns(valOben)
    sleep(1)

#Funktion zum öffnen des Mundes
def schliesseMund():
    global valUnten
    print("schliesseMund")
    pwm.duty_ns(valUnten)
    sleep(1)

#Funktion zum deinitialisieren der PWM Kanäle
def ende():
    pwm.deinit()

#initial soll der Mund geschlossen sein
schliesseMund()
while True:
    #lesen des Wertes vom Ultraschallabstandssensors
    value = readUltrasonicSensor()
    print(value)
    #Wenn der Wert kleiner als 4.5cm ist dann...
    if value < 4.5:
        #einen Ton ausgeben
        makeBeep()
        #eine Sekunde warten
        sleep(1)
        #Mund öffnen
        oeffneMund()
        #Mund schließen
        schliesseMund()
    #Warten von 0.2 Sekunden
    sleep(0.2)

#Beenden des Programmes
print("Programm beendet!")
ende()
